*Docker*
To run as docker:

cd <path to>/code-icse17
docker build -t code-icse17 .
docker run -v <path to>/code-icse17/src:/opt/icse17/src code-icse17

The output traces will be available in <path to>/code-icse17/src:
* Execution traces: icse17_trace.csv
* Control input traces: icse17_trace_control.csv
* Cleaned traces saved in: icse17_trace_filtered.csv

*Native (recommended)*
Despite easy to run in isolation and on every platform, [Docker](https://docs.docker.com/engine/installation/) achieves poor performance on this case study, especially on Windows and Mac due to the intemediate virtualization. To reduce the execution time, it is recommended to run the experiment natively.

After installing [Python 2.7](https://www.python.org/downloads) and [pip](https://pip.pypa.io/en/stable/installing/), install the required dependecies:

pip install numpy matplotlib cvxopt

Then:

cd <path to>/code-icse17
python loadBalancerSimulator3servicesMPC.py && python data_filter.py

To generate an exploration trace to be used in Matlab to generate the controller, modify src/loadBalancerSimulator3servicesMPC.py by commenting out the simulate method and uncommenting the simulateLearning(<filename>) method.

The MPC controller is initialized in libs/init_mpc.py . The automatically generated controller has been customized by setting the prediction horizon L to 100, the weights to reliability, performance, and cost to 10, 1, 10^-6 respectively, and the weights on the actuators p1, p2, l1, l2, l3 equal to 100 for the probabilities and 1 for the service levels. The tuning is based on direct experiments on the system.