import csv
import numpy as np

filename = 'icse17_trace'

pole = 0.9

rel_measureO = -np.inf
perf_measureO = -np.inf
cost_measureO = -np.inf

step = 0
filtered_rows = []

set_cost_goal_0 = False
skip_header = True

with open(filename+'.csv', 'rb') as csvfile:
    csvreader = csv.reader(csvfile, delimiter=',', quotechar='|', quoting=csv.QUOTE_MINIMAL)
    for row in csvreader:
        if skip_header:
            skip_header = False
            continue

        time = int(row[0])

        rel_goal = float(row[1])
        perf_goal = float(row[3])
        cost_goal = float(row[5]) if not set_cost_goal_0 else 0.0

        rel_error = float(row[2])
        perf_error = float(row[4])
        cost_error = float(row[6])

        rel_measure_raw = rel_goal - rel_error
        perf_measure_raw = perf_goal - perf_error
        cost_measure_raw = cost_goal - cost_error

        # Initialize filter with first value from data
        if rel_measureO == -np.inf:
            rel_measureO = rel_measure_raw
            perf_measureO = perf_measure_raw
            cost_measureO = cost_measure_raw

        rel_measure_filtered = pole*rel_measureO + (1.0-pole)*rel_measure_raw
        perf_measure_filtered = pole*perf_measureO + (1.0-pole)*perf_measure_raw
        cost_measure_filtered = pole*cost_measureO + (1.0-pole)*cost_measure_raw


        res = [step, time, rel_goal, rel_error, rel_measure_raw, rel_measure_filtered,perf_goal, perf_error, perf_measure_raw, perf_measure_filtered,cost_goal, cost_error, cost_measure_raw, cost_measure_filtered]

        filtered_rows.append(res)

        rel_measureO = rel_measure_filtered
        perf_measureO = perf_measure_filtered
        cost_measureO = cost_measure_filtered
        step += 1

with open(filename+'_filtered.csv', 'w') as csvfile:
    csvwriter = csv.writer(csvfile, delimiter=',',
                           quotechar='|', quoting=csv.QUOTE_MINIMAL)
    csvwriter.writerow(['step', 'time', 'rel_goal', 'rel_error', 'rel_measure_raw', 'rel_measure_filtered','perf_goal', 'perf_error', 'perf_measure_raw', 'perf_measure_filtered','cost_goal', 'cost_error', 'cost_measure_raw', 'cost_measure_filtered'])

    for row in filtered_rows:
        csvline = [str(val) for val in row]
        csvwriter.writerow(csvline)


print 'Cleaned traces saved in: '+str(filename)+'_filtered.csv\n'